Index: src/molecules.cpp
===================================================================
--- src/molecules.cpp	(revision 260934983a76c25770b6a1f5706e2fc4eb1eecec)
+++ src/molecules.cpp	(revision db942effae4d25e57224c90078ac288434a4a783)
@@ -3280,237 +3107,186 @@
   
   *out << endl;
-  *out << Verbose(0) << "Begin of CreateListOfUniqueFragmentsOfOrder with order " << Order << "." << endl;
-
-  RootStack.clear();  
-  // find first root candidates  
-  runner = Fragment.begin();
-  Walker = NULL;
-  while ((Walker == NULL) && (runner != Fragment.end())) { // search for first non-hydrogen atom
-    Walker = FindAtom((*runner));
-    *out << Verbose(4) << "Current Root candidate is " << Walker->Name << "." << endl;
+  *out << Verbose(0) << "Begin of PowerSetGenerator with order " << Order << " at Root " << *FragmentSearch.Root << "." << endl;
+
+  UniqueIndex = 0;
+  if (FragmentSearch.Labels[RootKeyNr] == -1)
+    FragmentSearch.Labels[RootKeyNr] = UniqueIndex++;
+  FragmentSearch.ShortestPathList[RootKeyNr] = 0;
+  // prepare the atom stack counters (number of atoms with certain SP on stack)
+  for (int i=0;i<Order;i++)
+    NumberOfAtomsSPLevel[i] = 0;
+  NumberOfAtomsSPLevel[0] = 1;  // for root
+  SP = -1;
+  *out << endl;
+  *out << Verbose(0) << "Starting BFS analysis ..." << endl;
+  // push as first on atom stack and goooo ...
+  AtomStack.clear();  
+  AtomStack.push_back(RootKeyNr);
+  *out << Verbose(0) << "Cleared AtomStack and pushed root as first item onto it." << endl;
+  // do a BFS search to fill the SP lists and label the found vertices
+  while (!AtomStack.empty()) {
+    // pop next atom
+    AtomKeyNr = AtomStack.front();
+    AtomStack.pop_front();
+    if (SP != -1)
+      NumberOfAtomsSPLevel[SP]--;
+    if ((SP == -1) || (NumberOfAtomsSPLevel[SP] == -1)) {
+      SP++;
+      NumberOfAtomsSPLevel[SP]--; // carry over "-1" to next level
+      *out << Verbose(1) << "New SP level reached: " << SP << ", creating new SP list with 0 item(s)";
+      if (SP > 0)
+        *out << ", old level closed with " << FragmentSearch.BondsPerSPCount[SP-1] << " item(s)." << endl;
+      else
+        *out << "." << endl;
+      FragmentSearch.BondsPerSPCount[SP] = 0;
+    } else {
+      *out << Verbose(1) << "Still " << NumberOfAtomsSPLevel[SP]+1 << " on this SP (" << SP << ") level, currently having " << FragmentSearch.BondsPerSPCount[SP] << " item(s)." << endl;
+    }
+    Walker = FindAtom(AtomKeyNr);
+    *out << Verbose(0) << "Current Walker is: " << *Walker << " with nr " << Walker->nr << " and label " << FragmentSearch.Labels[AtomKeyNr] << " and SP of " << SP << "." << endl;
+    // check for new sp level
+    // go through all its bonds
+    *out << Verbose(1) << "Going through all bonds of Walker." << endl;
+    for (int i=0;i<NumberOfBondsPerAtom[AtomKeyNr];i++) {
+      Binder = ListOfBondsPerAtom[AtomKeyNr][i];
+      OtherWalker = Binder->GetOtherAtom(Walker);
+      if ((RestrictedKeySet.find(OtherWalker->nr) != RestrictedKeySet.end())
 #ifdef ADDHYDROGEN
-    if (Walker->type->Z == 1) // skip hydrogen
-      Walker = NULL;
+       && (OtherWalker->type->Z != 1)
 #endif
-    runner++;
-  }
-  if (Walker != NULL)
-    RootStack.push_back(Walker->nr);
-  else
-    *out << Verbose(0) << "ERROR: Could not find an appropriate Root atom!" << endl;
-  
-  UniqueIndex = 0;
-  while (!RootStack.empty()) {
-    // Get Root and prepare
-    RootKeyNr = RootStack.front();
-    RootStack.pop_front();
-    FragmentSearch.Root = FindAtom(RootKeyNr);
-    if (FragmentSearch.Labels[RootKeyNr] == -1)
-      FragmentSearch.Labels[RootKeyNr] = UniqueIndex++;
-    FragmentSearch.ShortestPathList[RootKeyNr] = 0;
-    // prepare the atom stack counters (number of atoms with certain SP on stack)
-    for (int i=0;i<Order;i++)
-      NumberOfAtomsSPLevel[i] = 0;
-    NumberOfAtomsSPLevel[0] = 1;  // for root
-    SP = -1;
-    *out << endl;
-    *out << Verbose(0) << "Starting BFS analysis with current Root: " << *FragmentSearch.Root << "." << endl;
-    // push as first on atom stack and goooo ...
-    AtomStack.clear();  
-    AtomStack.push_back(RootKeyNr);
-    *out << Verbose(0) << "Cleared AtomStack and pushed root as first item onto it." << endl;
-    // do a BFS search to fill the SP lists and label the found vertices
-    while (!AtomStack.empty()) {
-      // pop next atom
-      AtomKeyNr = AtomStack.front();
-      AtomStack.pop_front();
-      if (SP != -1)
-        NumberOfAtomsSPLevel[SP]--;
-      if ((SP == -1) || (NumberOfAtomsSPLevel[SP] == -1)) {
-      ////if (SP < FragmentSearch.ShortestPathList[AtomKeyNr]) { // bfs has reached new SP level, hence allocate for new list
-        SP++;
-        NumberOfAtomsSPLevel[SP]--; // carry over "-1" to next level
-        ////SP = FragmentSearch.ShortestPathList[AtomKeyNr];
-        *out << Verbose(1) << "New SP level reached: " << SP << ", creating new SP list with 0 item(s)";
-        if (SP > 0)
-          *out << ", old level closed with " << FragmentSearch.BondsPerSPCount[SP-1] << " item(s)." << endl;
-        else
-          *out << "." << endl;
-        FragmentSearch.BondsPerSPCount[SP] = 0;
-      } else {
-        *out << Verbose(1) << "Still " << NumberOfAtomsSPLevel[SP]+1 << " on this SP (" << SP << ") level, currently having " << FragmentSearch.BondsPerSPCount[SP] << " item(s)." << endl;
-      }
-      Walker = FindAtom(AtomKeyNr);
-      *out << Verbose(0) << "Current Walker is: " << *Walker << " with nr " << Walker->nr << " and label " << FragmentSearch.Labels[AtomKeyNr] << " and SP of " << SP << "." << endl;
-      // check for new sp level
-      // go through all its bonds
-      *out << Verbose(1) << "Going through all bonds of Walker." << endl;
-      for (int i=0;i<NumberOfBondsPerAtom[AtomKeyNr];i++) {
-        Binder = ListOfBondsPerAtom[AtomKeyNr][i];
-        OtherWalker = Binder->GetOtherAtom(Walker);
-        if ((Fragment.find(OtherWalker->nr) != Fragment.end())
-#ifdef ADDHYDROGEN
-         && (OtherWalker->type->Z != 1)
-#endif
-                                                              ) {  // skip hydrogens and restrict to fragment
-          *out << Verbose(2) << "Current partner is " << *OtherWalker << " with nr " << OtherWalker->nr << " in bond " << *Binder << "." << endl;
-          // set the label if not set (and push on root stack as well)
-          if (FragmentSearch.Labels[OtherWalker->nr] == -1) {
-            RootStack.push_back(OtherWalker->nr);
-            FragmentSearch.Labels[OtherWalker->nr] = UniqueIndex++;
-            *out << Verbose(3) << "Set label to " << FragmentSearch.Labels[OtherWalker->nr] << "." << endl;
-          } else {
-            *out << Verbose(3) << "Label is already " << FragmentSearch.Labels[OtherWalker->nr] << "." << endl;
-          }
-          if ((OtherWalker != PredecessorList[AtomKeyNr]) && (FragmentSearch.Labels[OtherWalker->nr] > FragmentSearch.Labels[RootKeyNr])) { // only pass through those with label bigger than Root's
-            // set shortest path if not set or longer
-            //if ((FragmentSearch.ShortestPathList[OtherWalker->nr] == -1) || (FragmentSearch.ShortestPathList[OtherWalker->nr] > FragmentSearch.ShortestPathList[AtomKeyNr]))  {
-              FragmentSearch.ShortestPathList[OtherWalker->nr] = SP+1;
-              *out << Verbose(3) << "Set Shortest Path to " << FragmentSearch.ShortestPathList[OtherWalker->nr] << "." << endl;
-            //} else {
-            //  *out << Verbose(3) << "Shortest Path is already " << FragmentSearch.ShortestPathList[OtherWalker->nr] << "." << endl;
-            //}
-            if (FragmentSearch.ShortestPathList[OtherWalker->nr] < Order) { // only pass through those within reach of Order
-              // push for exploration on stack (only if the SP of OtherWalker is longer than of Walker! (otherwise it has been added already!)
-              if (FragmentSearch.ShortestPathList[OtherWalker->nr] > SP) {
-                if (FragmentSearch.ShortestPathList[OtherWalker->nr] < (Order-1)) {
-                  *out << Verbose(3) << "Putting on atom stack for further exploration." << endl;
-                  PredecessorList[OtherWalker->nr] = Walker;    // note down the one further up the exploration tree
-                  AtomStack.push_back(OtherWalker->nr);
-                  NumberOfAtomsSPLevel[FragmentSearch.ShortestPathList[OtherWalker->nr]]++;
-                } else {
-                  *out << Verbose(3) << "Not putting on atom stack, is at end of reach." << endl;
-                }
-                // add the bond in between to the SP list
-                Binder = new bond(Walker, OtherWalker); // create a new bond in such a manner, that bond::rightatom is always the one more distant
-                add(Binder, FragmentSearch.BondsPerSPList[2*SP+1]);
-                FragmentSearch.BondsPerSPCount[SP]++;
-                *out << Verbose(3) << "Added its bond to SP list, having now " << FragmentSearch.BondsPerSPCount[SP] << " item(s)." << endl;
+                                                            ) {  // skip hydrogens and restrict to fragment
+        *out << Verbose(2) << "Current partner is " << *OtherWalker << " with nr " << OtherWalker->nr << " in bond " << *Binder << "." << endl;
+        // set the label if not set (and push on root stack as well)
+        if (FragmentSearch.Labels[OtherWalker->nr] == -1) {
+          FragmentSearch.Labels[OtherWalker->nr] = UniqueIndex++;
+          *out << Verbose(3) << "Set label to " << FragmentSearch.Labels[OtherWalker->nr] << "." << endl;
+        } else {
+          *out << Verbose(3) << "Label is already " << FragmentSearch.Labels[OtherWalker->nr] << "." << endl;
+        }
+        if ((OtherWalker != PredecessorList[AtomKeyNr]) && (FragmentSearch.Labels[OtherWalker->nr] > FragmentSearch.Labels[RootKeyNr])) { // only pass through those with label bigger than Root's
+          FragmentSearch.ShortestPathList[OtherWalker->nr] = SP+1;
+          *out << Verbose(3) << "Set Shortest Path to " << FragmentSearch.ShortestPathList[OtherWalker->nr] << "." << endl;
+          if (FragmentSearch.ShortestPathList[OtherWalker->nr] < Order) { // only pass through those within reach of Order
+            // push for exploration on stack (only if the SP of OtherWalker is longer than of Walker! (otherwise it has been added already!)
+            if (FragmentSearch.ShortestPathList[OtherWalker->nr] > SP) {
+              if (FragmentSearch.ShortestPathList[OtherWalker->nr] < (Order-1)) {
+                *out << Verbose(3) << "Putting on atom stack for further exploration." << endl;
+                PredecessorList[OtherWalker->nr] = Walker;    // note down the one further up the exploration tree
+                AtomStack.push_back(OtherWalker->nr);
+                NumberOfAtomsSPLevel[FragmentSearch.ShortestPathList[OtherWalker->nr]]++;
               } else {
-                *out << Verbose(3) << "Not putting on atom stack, nor adding bond, as " << *OtherWalker << "'s SP is shorter than Walker's." << endl;
+                *out << Verbose(3) << "Not putting on atom stack, is at end of reach." << endl;
               }
-            } else {
-              *out << Verbose(3) << "Not continuing, as " << *OtherWalker << " is out of reach of order " << Order << "." << endl;
-            }
-          } else {
-            *out << Verbose(3) << "Not passing on, as label of " << *OtherWalker << " " << FragmentSearch.Labels[OtherWalker->nr] << " is smaller than that of Root " << FragmentSearch.Labels[RootKeyNr] << " or this is my predecessor." << endl;
-          }
-        } else {
-          *out << Verbose(2) << "Is not in the Fragment or skipping hydrogen " << *OtherWalker << "." << endl;
-        }
-      }
-    }
-    // reset predecessor list
-    for(int i=0;i<Order;i++) {
-      Binder = FragmentSearch.BondsPerSPList[2*i];
-      *out << Verbose(1) << "Current SP level is " << i << "." << endl;
-      while (Binder->next != FragmentSearch.BondsPerSPList[2*i+1]) {
+              // add the bond in between to the SP list
+              Binder = new bond(Walker, OtherWalker); // create a new bond in such a manner, that bond::rightatom is always the one more distant
+              add(Binder, FragmentSearch.BondsPerSPList[2*SP+1]);
+              FragmentSearch.BondsPerSPCount[SP]++;
+              *out << Verbose(3) << "Added its bond to SP list, having now " << FragmentSearch.BondsPerSPCount[SP] << " item(s)." << endl;
+            } else *out << Verbose(3) << "Not putting on atom stack, nor adding bond, as " << *OtherWalker << "'s SP is shorter than Walker's." << endl;
+          } else *out << Verbose(3) << "Not continuing, as " << *OtherWalker << " is out of reach of order " << Order << "." << endl;
+        } else *out << Verbose(3) << "Not passing on, as label of " << *OtherWalker << " " << FragmentSearch.Labels[OtherWalker->nr] << " is smaller than that of Root " << FragmentSearch.Labels[RootKeyNr] << " or this is my predecessor." << endl;
+      } else *out << Verbose(2) << "Is not in the retstricted keyset or skipping hydrogen " << *OtherWalker << "." << endl;
+    }
+  }
+  // reset predecessor list
+  for(int i=0;i<Order;i++) {
+    Binder = FragmentSearch.BondsPerSPList[2*i];
+    *out << Verbose(1) << "Current SP level is " << i << "." << endl;
+    while (Binder->next != FragmentSearch.BondsPerSPList[2*i+1]) {
+      Binder = Binder->next;
+      PredecessorList[Binder->rightatom->nr] = NULL;  // By construction "OtherAtom" is always Bond::rightatom!
+    } 
+  }
+  *out << endl;
+  
+  // outputting all list for debugging
+  *out << Verbose(0) << "Printing all found lists." << endl;
+  for(int i=0;i<Order;i++) {
+    Binder = FragmentSearch.BondsPerSPList[2*i];
+    *out << Verbose(1) << "Current SP level is " << i << "." << endl;
+    while (Binder->next != FragmentSearch.BondsPerSPList[2*i+1]) {
+      Binder = Binder->next;
+      *out << Verbose(2) << *Binder << endl;
+    } 
+  }
+  
+  // creating fragments with the found edge sets
+  SP = 0;
+  for(int i=0;i<Order;i++) { // sum up all found edges
+    Binder = FragmentSearch.BondsPerSPList[2*i];
+    while (Binder->next != FragmentSearch.BondsPerSPList[2*i+1]) {
+      Binder = Binder->next;
+      SP ++; 
+    }
+  }
+  *out << Verbose(0) << "Total number of edges is " << SP << "." << endl;
+  if (SP >= (Order-1)) {
+    // start with root (push on fragment stack)
+    *out << Verbose(0) << "Starting fragment generation with " << *FragmentSearch.Root << ", local nr is " << FragmentSearch.Root->nr << "." << endl;
+    FragmentSearch.FragmentSet->clear();  
+    FragmentSearch.FragmentSet->insert(FragmentSearch.Root->nr);
+    
+    if (FragmentSearch.FragmentSet->size() == (unsigned int) Order) {
+      *out << Verbose(0) << "Enough items on stack already for a fragment!" << endl;
+      // store fragment as a KeySet
+      *out << Verbose(2) << "Found a new fragment[" << FragmentSearch.FragmentCounter << "], local nr.s are: ";
+      for(KeySet::iterator runner = FragmentSearch.FragmentSet->begin(); runner != FragmentSearch.FragmentSet->end(); runner++) {
+        *out << (*runner) << " "; 
+      }
+      *out << endl;
+      InsertFragmentIntoGraph(out, &FragmentSearch);
+    } else {
+      *out << Verbose(0) << "Preparing subset for this root and calling generator." << endl;
+      // prepare the subset and call the generator
+      BondsList = (bond **) Malloc(sizeof(bond *)*FragmentSearch.BondsPerSPCount[0], "molecule::PowerSetGenerator: **BondsList");
+      Binder = FragmentSearch.BondsPerSPList[0];
+      for(int i=0;i<FragmentSearch.BondsPerSPCount[0];i++) {
         Binder = Binder->next;
-        PredecessorList[Binder->rightatom->nr] = NULL;  // By construction "OtherAtom" is always Bond::rightatom!
-      } 
-    }
-    *out << endl;
-    *out << Verbose(0) << "Printing all found lists." << endl;
-    // outputting all list for debugging
-    for(int i=0;i<Order;i++) {
-      Binder = FragmentSearch.BondsPerSPList[2*i];
-      *out << Verbose(1) << "Current SP level is " << i << "." << endl;
-      while (Binder->next != FragmentSearch.BondsPerSPList[2*i+1]) {
-        Binder = Binder->next;
-        *out << Verbose(2) << *Binder << endl;
-      } 
-    }
-    
-    // creating fragments with the found edge sets
-    SP = 0;
-    for(int i=0;i<Order;i++) { // sum up all found edges
-      Binder = FragmentSearch.BondsPerSPList[2*i];
-      while (Binder->next != FragmentSearch.BondsPerSPList[2*i+1]) {
-        Binder = Binder->next;
-        SP ++; 
-      }
-    }
-    *out << Verbose(0) << "Total number of edges is " << SP << "." << endl;
-    if (SP >= (Order-1)) {
-      // start with root (push on fragment stack)
-      *out << Verbose(0) << "Starting fragment generation with " << *FragmentSearch.Root << "." << endl;
-      FragmentSearch.FragmentSet->clear();  
-      FragmentSearch.FragmentSet->insert(FragmentSearch.Root->GetTrueFather()->nr);
-      
-      if (FragmentSearch.FragmentSet->size() == (unsigned int) Order) {
-        *out << Verbose(0) << "Enough items on stack already for a fragment!" << endl;
-        // store fragment as a KeySet
-        *out << Verbose(2) << "Found a new fragment[" << FragmentSearch.FragmentCounter << "], indices are: ";
-        for(KeySet::iterator runner = FragmentSearch.FragmentSet->begin(); runner != FragmentSearch.FragmentSet->end(); runner++) {
-          *out << (*runner)+1 << " "; 
-        }
-        *out << endl;
-        InsertFragmentIntoGraph(out, &FragmentSearch);
-        //StoreFragmentFromStack(out, FragmentSearch.Root, FragmentSearch.Leaflet, FragmentSearch.FragmentStack, FragmentSearch.ShortestPathList,FragmentSearch.Labels, &FragmentSearch.FragmentCounter, FragmentSearch.configuration);
-      } else {
-        *out << Verbose(0) << "Preparing subset for this root and calling generator." << endl;
-        // prepare the subset and call the generator
-        BondsList = (bond **) Malloc(sizeof(bond *)*FragmentSearch.BondsPerSPCount[0], "molecule::CreateListOfUniqueFragmentsOfOrder: **BondsList");
-        Binder = FragmentSearch.BondsPerSPList[0];
-        for(int i=0;i<FragmentSearch.BondsPerSPCount[0];i++) {
-          Binder = Binder->next;
-          BondsList[i] = Binder;
-        }
-        SPFragmentGenerator(out, &FragmentSearch, 0, BondsList, FragmentSearch.BondsPerSPCount[0], Order-1);  
-        Free((void **)&BondsList, "molecule::CreateListOfUniqueFragmentsOfOrder: **BondsList");
-      }
-    } else {
-      *out << Verbose(0) << "Not enough total number of edges to build " << Order << "-body fragments." << endl;
-    }
-    
-    // remove root from stack
-    *out << Verbose(0) << "Removing root again from stack." << endl;
-    FragmentSearch.FragmentSet->erase(FragmentSearch.Root->nr);    
-
-    // free'ing the bonds lists
-    *out << Verbose(0) << "Free'ing all found lists. and resetting index lists" << endl;
-    for(int i=0;i<Order;i++) {
-      *out << Verbose(1) << "Current SP level is " << i << ": ";
-      Binder = FragmentSearch.BondsPerSPList[2*i];
-      while (Binder->next != FragmentSearch.BondsPerSPList[2*i+1]) {
-        Binder = Binder->next;
-        FragmentSearch.ShortestPathList[Binder->leftatom->nr] = -1;
-        FragmentSearch.ShortestPathList[Binder->rightatom->nr] = -1;
-      }
-      // delete added bonds
-      cleanup(FragmentSearch.BondsPerSPList[2*i], FragmentSearch.BondsPerSPList[2*i+1]);
-      // also start and end node
-      *out << "cleaned." << endl;
-    }
-  }
-  
+        BondsList[i] = Binder;
+      }
+      SPFragmentGenerator(out, &FragmentSearch, 0, BondsList, FragmentSearch.BondsPerSPCount[0], Order-1);  
+      Free((void **)&BondsList, "molecule::PowerSetGenerator: **BondsList");
+    }
+  } else {
+    *out << Verbose(0) << "Not enough total number of edges to build " << Order << "-body fragments." << endl;
+  }
+
+/*  // as FragmentSearch structure is used only once, we don't have to clean it anymore
+  // remove root from stack
+  *out << Verbose(0) << "Removing root again from stack." << endl;
+  FragmentSearch.FragmentSet->erase(FragmentSearch.Root->nr);    
+
+  // free'ing the bonds lists
+  *out << Verbose(0) << "Free'ing all found lists. and resetting index lists" << endl;
+  for(int i=0;i<Order;i++) {
+    *out << Verbose(1) << "Current SP level is " << i << ": ";
+    Binder = FragmentSearch.BondsPerSPList[2*i];
+    while (Binder->next != FragmentSearch.BondsPerSPList[2*i+1]) {
+      Binder = Binder->next;
+      // *out << "Removing atom " << Binder->leftatom->nr << " and " << Binder->rightatom->nr << "." << endl; // make sure numbers are local
+      FragmentSearch.ShortestPathList[Binder->leftatom->nr] = -1;
+      FragmentSearch.ShortestPathList[Binder->rightatom->nr] = -1;
+    }
+    // delete added bonds
+    cleanup(FragmentSearch.BondsPerSPList[2*i], FragmentSearch.BondsPerSPList[2*i+1]);
+    // also start and end node
+    *out << "cleaned." << endl;
+  }
+*/
   // free allocated memory
-  Free((void **)&NumberOfAtomsSPLevel, "molecule::CreateListOfUniqueFragmentsOfOrder: *SPLevelCount");
-  Free((void **)&PredecessorList, "molecule::CreateListOfUniqueFragmentsOfOrder: **PredecessorList");
+  Free((void **)&NumberOfAtomsSPLevel, "molecule::PowerSetGenerator: *SPLevelCount");
+  Free((void **)&PredecessorList, "molecule::PowerSetGenerator: **PredecessorList");
   for(int i=0;i<Order;i++) { // delete start and end of each list
     delete(FragmentSearch.BondsPerSPList[2*i]);
     delete(FragmentSearch.BondsPerSPList[2*i+1]);
   }
-  Free((void **)&FragmentSearch.BondsPerSPList, "molecule::CreateListOfUniqueFragmentsOfOrder: ***BondsPerSPList");
-  Free((void **)&FragmentSearch.BondsPerSPCount, "molecule::CreateListOfUniqueFragmentsOfOrder: *BondsPerSPCount");
-  Free((void **)&FragmentSearch.ShortestPathList, "molecule::CreateListOfUniqueFragmentsOfOrder: *ShortestPathList");
-  Free((void **)&FragmentSearch.Labels, "molecule::CreateListOfUniqueFragmentsOfOrder: *Labels");
+  Free((void **)&FragmentSearch.BondsPerSPList, "molecule::PowerSetGenerator: ***BondsPerSPList");
+  Free((void **)&FragmentSearch.BondsPerSPCount, "molecule::PowerSetGenerator: *BondsPerSPCount");
+  Free((void **)&FragmentSearch.ShortestPathList, "molecule::PowerSetGenerator: *ShortestPathList");
+  Free((void **)&FragmentSearch.Labels, "molecule::PowerSetGenerator: *Labels");
   delete(FragmentSearch.FragmentSet);
   
-//  // gather all the leaves together
-//  *out << Verbose(0) << "Copying all fragments into MoleculeList structure." << endl; 
-//  FragmentList = new Graph;
-//  UniqueIndex = 0;
-//  while ((FragmentSearch.Leaflet != NULL) && (UniqueIndex < FragmentSearch.FragmentCounter))  {
-//    FragmentList->insert();
-//    FragmentList->ListOfMolecules[UniqueIndex++] = FragmentSearch.Leaflet->Leaf;
-//    FragmentSearch.Leaflet->Leaf = NULL; // prevent molecule from being removed
-//    TempLeaf = FragmentSearch.Leaflet;
-//    FragmentSearch.Leaflet = FragmentSearch.Leaflet->previous;
-//    delete(TempLeaf);
-//  };
-
   // return list  
-  *out << Verbose(0) << "End of CreateListOfUniqueFragmentsOfOrder." << endl;
+  *out << Verbose(0) << "End of PowerSetGenerator." << endl;
   return FragmentSearch.FragmentCounter;
 };
@@ -3664,5 +3440,5 @@
   GraphTestPair testGraphInsert;
 
-  testGraphInsert = Fragment->Leaflet->insert(GraphPair (*Fragment->FragmentSet,pair<int,double>(Fragment->FragmentCounter,Fragment->TEFactor)));  // store fragment number and current factor
+  testGraphInsert = Fragment->Leaflet->insert(GraphPair (*Fragment->FragmentSet,pair<int,double>(Fragment->FragmentCounter,1)));  // store fragment number and current factor
   if (testGraphInsert.second) {
     *out << Verbose(2) << "KeySet " << Fragment->FragmentCounter << " successfully inserted." << endl;
@@ -3670,5 +3446,5 @@
   } else {
     *out << Verbose(2) << "KeySet " << Fragment->FragmentCounter << " failed to insert, present fragment is " << ((*(testGraphInsert.first)).second).first << endl;
-    ((*(testGraphInsert.first)).second).second += Fragment->TEFactor;
+    ((*(testGraphInsert.first)).second).second ++;  // increase the "created" counter
     *out << Verbose(2) << "New factor is " << ((*(testGraphInsert.first)).second).second << "." << endl;
   }
@@ -3687,4 +3463,5 @@
  * \param graph1 first (dest) graph
  * \param graph2 second (source) graph
+ * \param *counter keyset counter that gets increased 
  */
 inline void InsertGraphIntoGraph(ofstream *out, Graph &graph1, Graph &graph2, int *counter)
@@ -3705,16 +3482,18 @@
 
 
-/** Creates truncated BOSSANOVA expansion up to order \a k.
+/** Performs BOSSANOVA decomposition at selected sites, increasing the cutoff by one at these sites.
+ * Important only is that we create all fragments, it is not important if we create them more than once
+ * as these copies are filtered out via use of the hash table (KeySet).
  * \param *out output stream for debugging
- * \param ANOVAOrder ANOVA expansion is truncated above this order
- * \param *configuration configuration for writing config files for each fragment
  * \return pointer to Graph list
  */
-Graph * molecule::FragmentBOSSANOVA(ofstream *out, int ANOVAOrder, config *configuration)
+Graph * molecule::FragmentBOSSANOVA(ofstream *out, KeyStack &RootStack)
 {
   Graph *FragmentList = NULL, ***FragmentLowerOrdersList = NULL;
-  //MoleculeListClass *FragmentMoleculeList = NULL;
   int Order, NumLevels, NumMolecules, TotalNumMolecules = 0, *NumMoleculesOfOrder = NULL;
   int counter = 0;
+  int UpgradeCount = RootStack.size();
+  KeyStack FragmentRootStack;
+  int RootKeyNr, RootNr;
   
   *out << Verbose(0) << "Begin of FragmentBOSSANOVA." << endl;
@@ -3722,8 +3501,8 @@
   // FragmentLowerOrdersList is a 2D-array of pointer to MoleculeListClass objects, one dimension represents the ANOVA expansion of a single order (i.e. 5)
   // with all needed lower orders that are subtracted, the other dimension is the BondOrder (i.e. from 1 to 5)
-  NumMoleculesOfOrder = (int *) Malloc(sizeof(int)*ANOVAOrder, "molecule::FragmentBOSSANOVA: *NumMoleculesOfOrder");
-  FragmentLowerOrdersList = (Graph ***) Malloc(sizeof(Graph **)*ANOVAOrder, "molecule::FragmentBOSSANOVA: ***FragmentLowerOrdersList");
-
-  // Construct the complete KeySet
+  NumMoleculesOfOrder = (int *) Malloc(sizeof(int)*UpgradeCount, "molecule::FragmentBOSSANOVA: *NumMoleculesOfOrder");
+  FragmentLowerOrdersList = (Graph ***) Malloc(sizeof(Graph **)*UpgradeCount, "molecule::FragmentBOSSANOVA: ***FragmentLowerOrdersList");
+
+  // Construct the complete KeySet which we need for topmost level only (but for all Roots)
   atom *Walker = start;
   KeySet CompleteMolecule;
